<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "practice_patient".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PracticePatient".
 *
 * Columns in table "practice_patient" available as properties of the model,
 * followed by relations of table "practice_patient" available as properties of the model.
 *
 * @property integer $id
 * @property integer $practice_id
 * @property integer $patient_id
 * @property integer $primary_practice
 * @property string $date_added
 * @property string $date_updated
 *
 * @property Patient $patient
 * @property Practice $practice
 */
abstract class BasePracticePatient extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'practice_patient';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PracticePatient|PracticePatients', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('practice_id, patient_id', 'required'),
            array('practice_id, patient_id, primary_practice', 'numerical', 'integerOnly' => true),
            array('date_added, date_updated', 'safe'),
            array('primary_practice, date_added, date_updated', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, practice_id, patient_id, primary_practice, date_added, date_updated', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'patient' => array(self::BELONGS_TO, 'Patient', 'patient_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'practice_id' => null,
            'patient_id' => null,
            'primary_practice' => Yii::t('app', 'Primary Practice'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'patient' => null,
            'practice' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('patient_id', $this->patient_id);
        $criteria->compare('primary_practice', $this->primary_practice);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
